<!DOCTYPE html>
<html>
<head>
	<title>JS function Exo CRC </title>
</head>
<body>

Cyclic Redundancy Check (CRC)


<script>

function toBinary (lettre) {

		// on transforme 1 lettre en langage binaire de 8 bits en mettant des 0 à gauche
		binary = ("00000000" + lettre.charCodeAt(0).toString(2)).slice(-8);
	return binary; //"01100010"
}

function toBinary2 (mot) {
	var binary2 = [];
	// le mot possède forcément une longueur de 8.
	while (mot.length < 8 ) {
		mot += String.fromCharCode(0);// on le remplit par du vide
		}
	// On transforme l'ensemble des lettres en binaire
	for (var i = 0; i < mot.length; i++) {
		binary2.push(toBinary(mot[i])); // on push une lettre en "binaire" dans le tableau
	}

	return binary2;
}

//on va parcourir ligne par ligne et caractère par caractère

function crcL (mot) {

mot = toBinary2 (mot);
resultatL = []; // on veut que les résultats aillent dans le tableau
calcL = 0;

for (var j = 0; j < mot.length; j++) {
	for (var k = 0; k < mot.length; k++) {
		calcL =  calcL + parseInt(mot[k].charAt(j));
		calcL = calcL % 2;
		resultatL.push(calcL);
	}
	calcL = 0;
	return resultatL; 
}
console.log("ligne: " + resultatL);
}
/////////////////// COLONNE //////////////////////////
function crcC (mot) {

mot = toBinary2 (mot);
resultatC = []; // on veut que les résultats aillent dans le tableau
calcC = 0;

for  (var k = 0; k < mot.length; k++) {
	for  (var j = 0; j < mot.length; j++) {
		calcC =  calcC + parseInt(mot[k].charAt(j));
		calcC = calcC % 2;
		resultatC.push(calcC);
	}
	calcC = 0;
	return resultatC; 
}
console.log("colonne: " + resultatC);
}


</script>




</body>
</html>





